commit 118cdbe2c678521ac6b69587b49c15520a6727b0
Author: freddy77 <freddy77>
Date:   Fri Sep 12 15:12:23 2008 +0000

    remove broken_money setting, remove is_binary_type macro, add no_data_conv option

diff --git a/ChangeLog b/ChangeLog
index 00c6825..c0f769f 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,11 @@
+Fri Sep 12 17:05:54 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/tds/config.c src/tds/token.c:
+	- removed is_binary_type macro, not used anymore
+	- removed broken_money setting, not used
+	- added no_data_conv to disable data conversions
+	* src/odbc/odbc.c src/odbc/unittests/data.c:
+	- updated to support no_data_conv
+
 Thu Sep 11 17:07:10 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tdsodbc.h src/odbc/convert_tds2sql.c src/odbc/odbc.c:
 	* src/odbc/odbc_util.c src/odbc/prepare_query.c src/odbc/sql2tds.c:
@@ -638,4 +646,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2606 2008/09/11 15:09:48 freddy77 Exp $
+$Id: ChangeLog,v 1.2607 2008/09/12 15:12:23 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index bdce7a6..a59f9ae 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.293 2008/08/14 08:49:22 freddy77 Exp $ */
+/* $Id: tds.h,v 1.294 2008/09/12 15:12:23 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -749,7 +749,6 @@ typedef enum tds_encryption_level {
 #define is_unicode_type(x) (x==XSYBNVARCHAR || x==XSYBNCHAR || x==SYBNTEXT)
 #define is_collate_type(x) (x==XSYBVARCHAR || x==XSYBCHAR || x==SYBTEXT || x==XSYBNVARCHAR || x==XSYBNCHAR || x==SYBNTEXT)
 #define is_ascii_type(x) ( x==XSYBCHAR || x==XSYBVARCHAR || x==SYBTEXT || x==SYBCHAR || x==SYBVARCHAR)
-#define is_binary_type(x) (x==SYBLONGBINARY)
 #define is_char_type(x) (is_unicode_type(x) || is_ascii_type(x))
 #define is_similar_type(x, y) ((is_char_type(x) && is_char_type(y)) || ((is_unicode_type(x) && is_unicode_type(y))))
 
@@ -790,7 +789,6 @@ typedef enum tds_encryption_level {
 #define TDS_STR_VERSION  "tds version"
 #define TDS_STR_BLKSZ    "initial block size"
 #define TDS_STR_SWAPDT   "swap broken dates"
-#define TDS_STR_SWAPMNY  "swap broken money"
 #define TDS_STR_DUMPFILE "dump file"
 #define TDS_STR_DEBUGLVL "debug level"
 #define TDS_STR_DEBUGFLAGS "debug flags"
@@ -884,9 +882,8 @@ typedef struct tds_connection
 	DSTR dump_file;
 	int debug_flags;
 	int text_size;
-	int broken_dates;
-	int broken_money;
-	int emul_little_endian;
+	unsigned int broken_dates:1;
+	unsigned int emul_little_endian:1;
 } TDSCONNECTION;
 
 typedef struct tds_locale
@@ -1291,8 +1288,12 @@ struct tds_socket
 	char *product_name;
 
 	unsigned char capabilities[TDS_MAX_CAPABILITY];
-	unsigned char broken_dates;
 	unsigned char option_flag2;
+	unsigned int broken_dates:1;
+	unsigned int emul_little_endian:1;
+#ifdef ENABLE_DEVELOPING
+	unsigned int no_data_conv:1;
+#endif
 
 	unsigned char *in_buf;		/**< input buffer */
 	unsigned char *out_buf;		/**< output buffer */
@@ -1332,7 +1333,6 @@ struct tds_socket
 	TDSDYNAMIC *cur_dyn;		/**< dynamic structure in use */
 	TDSDYNAMIC *dyns;		/**< list of dynamic allocate for this connection */
 
-	int emul_little_endian;
 	char *date_fmt;
 	const TDSCONTEXT *tds_ctx;
 	int char_conv_count;
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index bc6032a..edf4895 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.494 2008/09/11 15:09:49 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.495 2008/09/12 15:12:23 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -371,6 +371,9 @@ odbc_connect(TDS_DBC * dbc, TDSCONNECTION * connection)
 		odbc_errs_add(&dbc->errs, "HY001", NULL);
 		ODBC_RETURN(dbc, SQL_ERROR);
 	}
+#ifdef ENABLE_DEVELOPING
+	dbc->tds_socket->no_data_conv = 1;
+#endif
 	tds_set_parent(dbc->tds_socket, (void *) dbc);
 
 	/* Set up our environment change hook */
diff --git a/src/odbc/unittests/data.c b/src/odbc/unittests/data.c
index 5361db9..e76805a 100644
--- a/src/odbc/unittests/data.c
+++ b/src/odbc/unittests/data.c
@@ -3,7 +3,7 @@
 
 /* Test various bind type */
 
-static char software_version[] = "$Id: data.c,v 1.17 2008/08/27 07:44:39 freddy77 Exp $";
+static char software_version[] = "$Id: data.c,v 1.18 2008/09/12 15:12:24 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int result = 0;
@@ -133,7 +133,7 @@ main(int argc, char *argv[])
 	Test("MONEY", "4321234.5678", SQL_C_BINARY, big_endian ? "0000000A0FA8114E" : "0A0000004E11A80F");
 
 	/* behavior is different from MS ODBC */
-	if (db_is_microsoft() && !driver_is_freetds()) {
+	if (db_is_microsoft()) {
 		Test("NCHAR(7)", "donald", SQL_C_BINARY, "64006F006E0061006C0064002000");
 		Test("NTEXT", "duck", SQL_C_BINARY, "6400750063006B00");
 		Test("NVARCHAR(20)", "daffy", SQL_C_BINARY, "64006100660066007900");
diff --git a/src/tds/config.c b/src/tds/config.c
index 22356ff..3b8f6e7 100644
--- a/src/tds/config.c
+++ b/src/tds/config.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: config.c,v 1.136 2008/08/18 13:31:27 freddy77 Exp $");
+TDS_RCSID(var, "$Id: config.c,v 1.137 2008/09/12 15:12:23 freddy77 Exp $");
 
 static void tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login);
 static void tds_config_env_tdsdump(TDSCONNECTION * connection);
@@ -220,7 +220,6 @@ tds_read_config_info(TDSSOCKET * tds, TDSLOGIN * login, TDSLOCALE * locale)
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %x\n", "debug_flags", connection->debug_flags);
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "text_size", connection->text_size);
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "broken_dates", connection->broken_dates);
-		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "broken_money", connection->broken_money);
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "emul_little_endian", connection->emul_little_endian);
 
 		tdsdump_close();
@@ -500,8 +499,6 @@ tds_parse_conf_section(const char *option, const char *value, void *param)
 			connection->block_size = val;
 	} else if (!strcmp(option, TDS_STR_SWAPDT)) {
 		connection->broken_dates = tds_config_boolean(value);
-	} else if (!strcmp(option, TDS_STR_SWAPMNY)) {
-		connection->broken_money = tds_config_boolean(value);
 	} else if (!strcmp(option, TDS_STR_DUMPFILE)) {
 		tds_dstr_copy(&connection->dump_file, value);
 	} else if (!strcmp(option, TDS_STR_DEBUGFLAGS)) {
diff --git a/src/tds/token.c b/src/tds/token.c
index d8321f5..210834f 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.351 2008/08/18 13:31:28 freddy77 Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.352 2008/09/12 15:12:23 freddy77 Exp $");
 
 static int tds_process_msg(TDSSOCKET * tds, int marker);
 static int tds_process_compute_result(TDSSOCKET * tds);
@@ -2099,7 +2099,14 @@ tds_get_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		 * Here we allocate memory, if need be.  
 		 */
 		/* TODO this can lead to a big waste of memory */
+#ifdef ENABLE_DEVELOPING
+		if (!tds->no_data_conv)
+			new_blob_size = determine_adjusted_size(curcol->char_conv, colsize);
+		else
+			new_blob_size = colsize;
+#else
 		new_blob_size = determine_adjusted_size(curcol->char_conv, colsize);
+#endif
 		if (new_blob_size == 0) {
 			curcol->column_cur_size = 0;
 			if (blob->textvalue)
@@ -2123,7 +2130,11 @@ tds_get_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		curcol->column_cur_size = new_blob_size;
 		
 		/* read the data */
-		if (is_char_type(curcol->column_type)) {
+#ifdef ENABLE_DEVELOPING
+		if (!tds->no_data_conv && curcol->char_conv) {
+#else
+		if (curcol->char_conv) {
+#endif
 			if (tds_get_char_data(tds, (char *) blob, colsize, curcol) == TDS_FAIL)
 				return TDS_FAIL;
 		} else {
@@ -2133,7 +2144,11 @@ tds_get_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 	} else {		/* non-numeric and non-blob */
 		curcol->column_cur_size = colsize;
 
+#ifdef ENABLE_DEVELOPING
+		if (!tds->no_data_conv && curcol->char_conv) {
+#else
 		if (curcol->char_conv) {
+#endif
 			if (tds_get_char_data(tds, (char *) dest, colsize, curcol) == TDS_FAIL)
 				return TDS_FAIL;
 		} else {	
@@ -3365,7 +3380,7 @@ adjust_character_column_size(const TDSSOCKET * tds, TDSCOLUMN * curcol)
 	if (!curcol->char_conv && IS_TDS7_PLUS(tds) && is_ascii_type(curcol->on_server.column_type))
 		curcol->char_conv = tds->char_convs[client2server_chardata];
 
-	if (!curcol->char_conv)
+	if (tds->no_data_conv || !curcol->char_conv)
 		return;
 
 	curcol->on_server.column_size = curcol->column_size;

